#ifndef SCREENHPP
#define SCREENHPP
#include <string.h>
#include <stdlib.h>

#include "icon.hpp"
#include "listmgr.hpp"
#include "events.hpp"
#include "legend.hpp"
#include "limit.hpp"
#include "pagesel.hpp"
#include "descrip.hpp"
#include "box.hpp"

#define SCREEN_X1 0
#define SCREEN_Y1 0
#define SCREEN_X2 639
#define SCREEN_Y2 349

#define WORK_PAGE_X1 0
#define WORK_PAGE_Y1 0
#define WORK_PAGE_X2 560
#define WORK_PAGE_Y2 349

#define SCREEN_TITLE_X1 1
#define SCREEN_TITLE_Y1 325
#define SCREEN_TITLE_X2 560
#define SCREEN_TITLE_Y2 349

#define PAGE_SELECTOR_X1 565
#define PAGE_SELECTOR_Y1 0
#define PAGE_SELECTOR_X2 639
#define PAGE_SELECTOR_Y2 439

class Screen {

	DisplayList display_list;	// list of all objects on 							// the screen
	Icon* work_area;			// points to page in work 							// area
	COLOR_TYPE background_color;	// of work page
	PageSelector* page;		// page selector buttons
	Icon* left_button_icon;		// last icon clicked

public:

	Screen();
	int NumberOfIcons() {return display_list. Size();}
	void DisplayTemplate();
	void ClearArea(int, int, int, int);
	void ClearWorkArea();
	void NewWorkArea(Icon*);
	void DisplayWorkArea();

	void ReDraw(int, int, int, int);
	void AddItem(Icon*);
	void RemoveItem(Icon*);
	void Update();
	void LeftButtonChanged(int, int, int);
	Icon* CurrentIcon(int x, int y);
	void LeftButtonDragged(int x, int y,
			       int delta_x, int delta_y,
			       int status);
	void KeyTyped(int, int, int);

	void SetPageSelector(PageSelector* pg)	{page = pg;}
	PageSelector* GetPageSelector()         {return page;}

	~Screen();
};

extern Screen* CurrentScreen;

#endif

